/// <reference types="react" />
import type { DCloneHTMLElement, DSize } from '../../utils/types';
import type { DFormControl } from '../form';
export interface DInputProps extends Omit<React.HTMLAttributes<HTMLDivElement>, 'children'> {
    dRef?: {
        input?: React.ForwardedRef<HTMLInputElement>;
    };
    dFormControl?: DFormControl;
    dModel?: string;
    dType?: React.HTMLInputTypeAttribute;
    dPrefix?: React.ReactNode;
    dSuffix?: React.ReactNode;
    dPassword?: boolean;
    dNumbetButton?: boolean;
    dClearable?: boolean;
    dSize?: DSize;
    dMax?: number;
    dMin?: number;
    dStep?: number;
    dInteger?: boolean;
    dPlaceholder?: string;
    dDisabled?: boolean;
    dInputRender?: DCloneHTMLElement<React.InputHTMLAttributes<HTMLInputElement>>;
    onModelChange?: (value: string) => void;
    onClear?: () => void;
    onPasswordChange?: (value: boolean) => void;
}
export declare function DInput(props: DInputProps): JSX.Element | null;
