import type { DId } from '../../utils/types';
import React from 'react';
export interface DSlideItem<ID extends DId> {
    id: ID;
    tooltip?: string;
    content: React.ReactNode;
}
interface DAutoplayOptions {
    delay?: number;
    stopOnLast?: boolean;
    pauseOnMouseEnter?: boolean;
}
interface DPaginationOptions {
    visible?: boolean | 'hover';
    dynamic?: boolean;
}
export interface DSlidesProps<ID extends DId, T extends DSlideItem<ID>> extends Omit<React.HTMLAttributes<HTMLDivElement>, 'children'> {
    dList: T[];
    dActive?: ID;
    dAutoplay?: number | DAutoplayOptions;
    dArrow?: boolean | 'hover';
    dPagination?: boolean | 'hover' | DPaginationOptions;
    dEffect?: 'slide' | 'fade';
    dVertical?: boolean;
    onActiveChange?: (id: any, slide: any) => void;
}
export declare function DSlides<ID extends DId, T extends DSlideItem<ID>>(props: DSlidesProps<ID, T>): JSX.Element | null;
export {};
