import type { DCloneHTMLElement, DSize } from '../../utils/types';
import type { DFormControl } from '../form';
import React from 'react';
export interface DTimePickerRef {
    updatePosition: () => void;
}
export interface DTimePickerProps extends Omit<React.HTMLAttributes<HTMLDivElement>, 'children'> {
    dRef?: {
        inputLeft?: React.ForwardedRef<HTMLInputElement>;
        inputRight?: React.ForwardedRef<HTMLInputElement>;
    };
    dFormControl?: DFormControl;
    dModel?: Date | null | [Date, Date];
    dFormat?: string;
    dVisible?: boolean;
    dInitialVisible?: boolean;
    dPlacement?: 'top' | 'top-left' | 'top-right' | 'bottom' | 'bottom-left' | 'bottom-right';
    dOrder?: 'ascend' | 'descend' | false;
    dPlaceholder?: string | [string?, string?];
    dRange?: boolean;
    dSize?: DSize;
    dClearable?: boolean;
    dDisabled?: boolean;
    dConfigTime?: (unit: 'hour' | 'minute' | 'second', value: number, position: 'start' | 'end', current: [Date | null, Date | null]) => {
        disabled?: boolean;
        hidden?: boolean;
    };
    d12Hour?: boolean;
    dPopupClassName?: string;
    dInputRender?: [
        DCloneHTMLElement<React.InputHTMLAttributes<HTMLInputElement>>?,
        DCloneHTMLElement<React.InputHTMLAttributes<HTMLInputElement>>?
    ];
    onModelChange?: (date: any) => void;
    onVisibleChange?: (visible: boolean) => void;
    afterVisibleChange?: (visible: boolean) => void;
    onClear?: () => void;
}
export declare const DTimePicker: React.ForwardRefExoticComponent<DTimePickerProps & React.RefAttributes<DTimePickerRef>>;
